<cfinclude template="template/header.cfm" />
<cfimport taglib="/CFUniform-Preso/cfMgmt/tags/forms/UniForm/" prefix="uform" />
<cfparam name="errors" default="#structNew()#" />

<!--- param our form variables --->
<cfparam name="form.emailAddress" type="string" default="" />
<cfparam name="form.password" type="string" default="" />
<cfparam name="form.password2" type="string" default="" />
<cfparam name="form.firstName" type="string" default="" />
<cfparam name="form.lastName" type="string" default="" />
<cfparam name="form.skillsInterests" type="string" default="" />
<cfparam name="form.screenName" type="string" default="" />
<cfparam name="form.displayOptions" type="string" default="" />
<cfparam name="form.country" type="string" default="" />
<cfparam name="form.state" type="string" default="TX" />
<cfparam name="form.address" type="string" default="" />
<cfparam name="form.city" type="string" default="" />
<cfparam name="form.zip" type="string" default="" />
<cfparam name="form.phone" type="string" default="88h201941" />
<cfparam name="form.cellPhone" type="string" default="" />
<cfparam name="form.gender" type="string" default="" />
<cfparam name="form.aboutYou" type="string" default="" />

<cfscript>
	// let's create an error struct for the sake of demonstration
	errorStruct = structNew();
	errorStruct.password = "Passwords don't match.";
	errorStruct.country = "Please select the country in which you reside.";
	errorStruct.phone = "Please provide a properly formatted telephone number.";
</cfscript>
<div class="formContainer">
	<uform:form action="doFormDump.cfm" 
				id="myForm" 
				errors="#errorStruct#"				
				loadValidation="true" 
				loadJQuery="true"
				loadDateUI="true" 
				loadTimeUI="true"
				loadMaskUI="true"
				config="#_assetConfig#">
		<uform:fieldset legend="Required Fields">
			<input type="hidden" name="foo" value="1" />
			<uform:field label="Email Address" name="emailAddress" isRequired="true" type="text" value="#form.emailAddress#" hint="Note: Your email is your username.  Use a valid email address."  />
			<uform:field label="Choose Password" name="password" isRequired="true" type="password"  /><!--- for security purposes, we don't populate the password --->
			<uform:field label="Re-enter Password" name="password2" isRequired="true" type="password"  /><!--- for security purposes, we don't populate the password --->
			<uform:field label="First Name" name="firstName" isRequired="true" type="text" value="#form.firstName#"  />
			<uform:field label="Last Name" name="lastName" isRequired="true" type="text" value="#form.lastName#"  />
			<uform:field label="Skills and Interests" name="skillsInterests" isRequired="true" type="textarea" value="#form.skillsInterests#" hint='Enter your skills and interests by terms separated with commas (E.g. computers, GTD, running). Will be presented on your profile as a <a href="http://en.wikipedia.org/wiki/Tag_cloud" title="Definition of a tag cloud on Wikipedia">tag cloud</a>.'  />
			<uform:field label="Screen Name" name="screenName" isRequired="true" type="text" value="#form.screenName#" hint="Note: Used on the message board."  />
			<uform:field label="Upload Picture" name="upload" type="file" hint="Your image will be resized to 80x80 pixels."  />
			<uform:field label="Display Options" name="displayOptions" type="checkboxgroup"><!--- this is a checkboxgroup, so the submitted form will result in a comma-delimmited list of values (one for each item that is checked) --->
				<uform:checkbox label="Display my email address" value="email" isChecked="#listFindNoCase(form.displayOptions, 'email') GT 0#" />
				<uform:checkbox label="Display my picture" value="pic" isChecked="#listFindNoCase(form.displayOptions, 'pic') GT 0#" />
			</uform:field>
		</uform:fieldset>
		<uform:fieldset legend="Optional Fields" class="blockLabels">
			<p>This fieldset has the class <code>blockLabels</code> applied to it, and as a result we get a different form layout.</p>
			<uform:field label="Country" name="country" type="select">
				<uform:countryCodes defaultCountry="" />
			</uform:field>
			<uform:field label="State / Province" name="state" type="select">
				<uform:states-us defaultState="TX" showUS="true" />
				<uform:states-can showSelect="false" />
			</uform:field>
			<uform:field label="Address" name="address" type="text" value="#form.address#" hint="e.g.: 123 Any Street"  />
			<uform:field label="City" name="city" type="text" value="#form.city#"  />
			<uform:field label="Zip / Postal Code" name="zip" type="text" value="#form.zip#"  />
			<uform:field label="Telephone" name="phone" type="text" value="#form.phone#" hint="e.g.: 202-555-1212" mask="(999) 999-9999"  />
			<uform:field label="Cell Phone" name="cellPhone" type="text" value="#form.cellPhone#" hint="e.g.: 202-555-1212" mask="(999) 999-9999"  />
			<uform:field label="Gender" name="gender" type="radio">
				<uform:radio label="Male" value="1" isChecked="#form.gender EQ 1#" />
				<uform:radio label="Female" value="2" isChecked="#form.gender EQ 2#" />
			</uform:field>
			<uform:field label="About You" name="aboutYou" type="textarea" value="#form.aboutYou#" hint="Tell us something about yourself in 300 words or less."  />
			<uform:field label="Send me your news and information (a.k.a. junk)" name="newsletter" value="1" type="checkbox" isChecked="#structKeyExists(form, 'newsletter')#"  /><!--- regular checkbox; it will either exist or not exist when the form is submitted --->
			<uform:field label="I have read and agree to your <a href='/'>privacy policy</a>" name="i_agree" value="1" type="checkbox" isChecked="#structKeyExists(form, 'i_agree')#"  /><!--- regular checkbox; it will either exist or not exist when the form is submitted --->
		</uform:fieldset>
	</uform:form>
	
</div>


<cfinclude template="template/footer.cfm" />